# Redmine - project management software
# Copyright (C) 2006-2013  Jean-Philippe Lang
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
class ProjectsController < ApplicationController
  layout :select_project_layout

  menu_item :overview
  menu_item :roadmap, :only => :roadmap
  menu_item :settings, :only => :settings
  
  menu_item l(:label_sort_by_time), :only => :index
  menu_item l(:label_sort_by_active), :only => :index
  menu_item l(:label_sort_by_influence), :only => :index
  
  # menu_item l(:label_homework), :only => :homework
  # menu_item l(:label_course_feedback), :only => :feedback
  menu_item :homework, :only => [:homework, :new_homework]
  menu_item :feedback, :only => :feedback
  menu_item l(:label_course_file), :only => :index
  menu_item l(:label_course_news), :only => :index
  

  before_filter :find_project, :except => [ :index, :search,:list, :new, :create, :copy, :statistics, :new_join, :course, :enterprise_course, :course_enterprise,:view_homework_attaches]
  # before_filter :authorize, :except => [:new_join, :new_homework, :homework, :statistics, :search, :watcherlist, :index, :list, :new, :create, :copy, :archive, :unarchive, :destroy, :member, :focus, :file, 
  #               :statistics, :feedback, :course, :enterprise_course, :course_enterprise, :project_respond, :share,
  #               :show_projects_score, :issue_score_index, :news_score_index, :file_score_index, :code_submit_score_index, :projects_topic_score_index]
  #此条勿删 课程相关权限  ,:new_homework,:homework,:feedback,,:member
  before_filter :authorize, :only => [:show, :settings, :edit, :sort_project_members, :update, :modules, :close, :reopen,:view_homework_attaches,:course]
  before_filter :authorize_global, :only => [:new, :create,:view_homework_attaches]
  before_filter :require_admin, :only => [ :copy, :archive, :unarchive, :destroy, :calendar]
  before_filter :file, :statistics, :watcherlist
  #before_filter :find_project_repository, :only => [:show]
  # 除非项目内人员，不可查看成员, TODO: 完了写报表里去
  before_filter :memberAccess, only: :member

  accept_rss_auth :index
  accept_api_auth :index, :show, :create, :update, :destroy

  after_filter :only => [:create, :edit, :update, :archive, :unarchive, :destroy] do |controller|
    if controller.request.post?
      controller.send :expire_action, :controller => 'welcome', :action => 'robots'
    end
  end

  helper :bids
  include BidsHelper
  helper :contests
  include ContestsHelper
  helper :sort
  include SortHelper
  helper :custom_fields
  include CustomFieldsHelper
  helper :issues
  helper :queries
  include QueriesHelper
  helper :repositories
  include RepositoriesHelper
  include ProjectsHelper
  helper :members
  helper :activities
  helper :documents
  helper :watchers
  # helper :watcherlist
  helper :words
  helper :project_score
  helper :user_score
  ### added by william
  include ActsAsTaggableOn::TagsHelper

  def find_project_repository
    unless @project.repositories.nil?
      @project.repositories.each do |repository|
        repository.fetch_changesets if Setting.autofetch_changesets?
      end
    end
  end

  def enterprise_course
    session[:enterprise_college] = 2
    respond_to do |format|
      format.html { redirect_to :back }
    #format.api { render_api_ok }
    end
  end
  
  def course_enterprise
    session[:enterprise_college] = 1
    respond_to do |format|
      format.html { redirect_to :back }
    #format.api { render_api_ok }
    end
  end

  def index
    render_404
    #调用存储过程更新提交次数
    #ActiveRecord::Base.connection.execute("CALL sp_project_status_cursor();")
    #Modified by nie
    @project_type = params[:project_type].to_i
    per_page_option = 10

    @projects_all = Project.active.visible.
                      joins("LEFT JOIN #{ProjectStatus.table_name} ON #{Project.table_name}.id = #{ProjectStatus.table_name}.project_id").joins("LEFT JOIN #{ProjectScore.table_name} ON #{Project.table_name}.id = #{ProjectScore.table_name}.project_id").
                      where("#{Project.table_name}.project_type = ? ", Project::ProjectType_project)

    @project_count = @projects_all.count
    @project_pages = Paginator.new @project_count, per_page_option, params['page']

#gcm activity count

    @project_activity_count=Hash.new

    @projects_all.each do |project|
      @project_activity_count[project.id]=0
    end

    @project_activity_count=get_project_activity @projects_all,@project_activity_count

#gcm end

    case params[:project_sort_type]
    when '0'
      @projects =  @projects_all.order("created_on desc")
      @s_type = 0
    when '1'
      @projects = @projects_all.order("score desc")
      @s_type = 1
    when '2'
      @projects = @projects_all.order("watchers_count desc")
      @s_type = 2

      #gcm
    when '3'
      #@projects=desc_sort_course_by_avtivity(@project_activity_count_array,@project_all_array)
      @projects=handle_project @projects_all,@project_activity_count
      @s_type = 3
      @projects =  @projects[@project_pages.offset, @project_pages.per_page]

    else
      @projects = @projects = @projects_all.order("score desc")
      @s_type = 1
    end
    @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)


    respond_to do |format|
      format.html {        
        # render :layout => 'base'
        # scope = Project
        # unless params[:closed]
        # scope = scope.active
        # end
      }
      format.api  {
      #        @offset, @limit = api_offset_and_limit
      #        @project_count = Project.visible.count
      #        @projects = Project.visible.offset(@offset).limit(@limit).order('lft').all
      }
      format.atom {
        projects = Project.visible.order('created_on DESC').limit(Setting.feeds_limit.to_i).all
        render_feed(projects, :title => "#{Setting.app_title}: #{l(:label_project_latest)}")
      }
    end
  end
  
  def course
    @project_type = params[:project_type]
    @school_id = params[:school_id]
    per_page_option = 10
    if @school_id == "0" or @school_id.nil?
      @projects_all = Project.active.visible.
                        joins("LEFT JOIN #{ProjectStatus.table_name} ON #{Project.table_name}.id = #{ProjectStatus.table_name}.project_id").
                        where("#{Project.table_name}.project_type = ? ", Project::ProjectType_course)    
    else
      @projects_all = Project.active.visible.
                        joins("LEFT JOIN #{ProjectStatus.table_name} ON #{Project.table_name}.id = #{ProjectStatus.table_name}.project_id").
                        joins(:course_extra).
                        where("#{Project.table_name}.project_type = ?  AND #{Course.table_name}.school_id = ?", Project::ProjectType_course, @school_id)
    end

    @project_count = @projects_all.count
    @project_pages = Paginator.new @project_count, per_page_option, params['page']
    
    #gcm activity count

    @project_activity_count=Hash.new
    #count initialize
    @projects_all.each do |project|
      @project_activity_count[project.id]=0
    end

    #@project_activity_count=get_project_activity @projects_all,@project_activity_count
    #gcm end


    case params[:project_sort_type]
    when '0'
      @projects =  @projects_all.order("created_on desc")
      @s_type = 0
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    when '1'
      @projects = @projects_all.order("course_ac_para desc")
      @s_type = 1
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    when '2'
      @projects = @projects_all.order("watchers_count desc")
      @s_type = 2
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    #gcm
    when '3'

      #gcm
      @project_activity_count=get_project_activity @projects_all,@project_activity_count
      #gcmend

      @projects=handle_project @projects_all,@project_activity_count
      @s_type = 3
      @projects =  @projects[@project_pages.offset, @project_pages.per_page]
    else
      @s_type = 0
      @projects = @projects_all.order("created_on desc")
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    end

    respond_to do |format|
      format.html {
        render :layout => 'base'
      }
      format.api  {
      #        @offset, @limit = api_offset_and_limit
      #        @project_count = Project.visible.count
      #        @projects = Project.visible.offset(@offset).limit(@limit).order('lft').all
      }
      format.atom {
        projects = Project.visible.order('created_on DESC').limit(Setting.feeds_limit.to_i).all
        render_feed(projects, :title => "#{Setting.app_title}: #{l(:label_project_latest)}")
      }
    end
  end

#gcm
  def search
    #modified by nie
    project_type = params[:project_type].to_i
    projects_all = (project_type.eql? Project::ProjectType_course) ? Project.course_entities : Project.project_entities
    @projects = projects_all.visible
    #@projects_all = @projects.visible.like(params[:name]) if params[:name].present?
    if params[:name].present?
      @projects_all = @projects.visible.like(params[:name])
    else
      @projects_all =  @projects;
    end
        @project_count = @projects_all.count
    @project_pages = Paginator.new @project_count, per_page_option, params['page']
    
    #gcm activity count

    @project_activity_count=Hash.new
    # count initialize
    @projects_all.each do |project|
      @project_activity_count[project.id]=0
    end

    #@project_activity_count=get_project_activity @projects_all,@project_activity_count

    #gcm end


    case params[:project_sort_type]
    when '0'
      @projects =  @projects_all.order("created_on desc")
      @s_type = 0
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    when '1'
      @projects = @projects_all.order("course_ac_para desc")
      @s_type = 1
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    when '2'
      @projects = @projects_all.order("watchers_count desc")
      @s_type = 2
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    when '3'
      #@projects=desc_sort_course_by_avtivity(@project_activity_count_array,@project_all_array)
      @project_activity_count=get_project_activity @projects_all,@project_activity_count_array        #gcm
      @projects=handle_project @projects_all,@project_activity_count
      @s_type = 3
      @projects =  @projects[@project_pages.offset, @project_pages.per_page]

    else
      @s_type = 0
      @projects = @projects_all.order("created_on desc")
      @projects =  @projects.offset(@project_pages.offset).limit(@project_pages.per_page)

      #gcm
      @project_activity_count=get_project_activity @projects,@project_activity_count
      #gcmend

    end
    
    respond_to do |format|
      format.html {
        render :layout => 'base'
        scope = Project
        unless params[:closed]
        scope = scope.active
        end
      }
      format.api  {
      #        @offset, @limit = api_offset_and_limit
      #        @project_count = Project.visible.count
      #        @projects = Project.visible.offset(@offset).limit(@limit).order('lft').all
      }
      format.atom {
        projects = Project.visible.order('created_on DESC').limit(Setting.feeds_limit.to_i).all
        render_feed(projects, :title => "#{Setting.app_title}: #{l(:label_project_latest)}")
      }
    end 
  end
#gcmend


  #Added by young
  def homework
    @offset, @limit = api_offset_and_limit({:limit => 10})
    @bids = @project.homeworks.order('deadline')
    @bids = @bids.like(params[:name]) if params[:name].present?

    @bids = paginateHelper @bids
    render :layout => 'base_courses'
   
  end

  def new_homework
    # Dear maintainer:
    # once you are done trying to 'optimize' this Magic routine,
    # well, it's on you, I'll leave it to you.
    if (User.current.logged? && 
        (User.current.admin? || 
          (
            !Member.where('user_id = ? and project_id = ?', User.current.id, @project.id).first.nil? && 
            (
              Member.where('user_id = ? and project_id = ?', User.current.id, @project.id).first.roles &&
              ( Role.where(id: [3, 4, 7, 9]).size > 0 )
            )
          )
        )
      )
    @homework = Bid.new
    @homework.safe_attributes = params[:bid]
    render :layout => 'base_courses'
    else
      render_404
    end
      
  end
  #Ended by young

  def feedback
    @page = params[:page]
    @page = @page.to_i
    # Find the page of the requested reply
    @jours = @project.journals_for_messages.where('m_parent_id IS NULL').order('created_on DESC')
    @limit =  10

    offset = @jours.count(:conditions => ["#{JournalsForMessage.table_name}.id > ?", params[:r].to_i])
    page = 1 + offset / @limit
    if params[:r] && @page.nil?
      @page = page
    end

    puts @page
    if @page < 0
      @page = 1
    end
    if @page > page
      @page = page
    end


    #@feedback_count = @jours.count
    #@feedback_pages = Paginator.new @feedback_count, @limit, @page
    #@offset ||= @feedback_pages.offset
    @jour = paginateHelper @jours,10
    @state = false
    @base_courses_tag = @project.project_type


    respond_to do |format|
      format.html{render :layout => 'base_courses' if @base_courses_tag==1}
      format.api
    end
  end

  def project_respond
    # will_reply = JournalsForMessage.find(params[:reference_id]) if params[:reference_id]
    project_id = request.headers["Referer"].match((%r|/([0-9]{1,})/|))[1]
    # @project = Project.find_by_id(project_id)
    parent_id = params[:reference_id]
    author_id = User.current.id
    reply_user_id = params[:reference_user_id]
    reply_id = params[:reference_message_id]
    content = params[:project_respond]
    options = {:user_id => author_id, 
              :m_parent_id => parent_id,
              :m_reply_id => reply_id,
              :reply_id => reply_user_id,
              :notes => content, 
              :is_readed => false}

    @jfm = Project.add_new_jour(nil, nil, project_id, options)
    @save_succ = @jfm.errors.empty?

    # flash[:notice]=l(:label_projects_feedback_respond_success)

    respond_to do |format|
      # format.html { redirect_to :back }
      format.js
    #format.api { render_api_ok }
    end
  end

  def new
    @issue_custom_fields = IssueCustomField.sorted.all
    @trackers = Tracker.sorted.all
    @project = Project.new
    @project.safe_attributes = params[:project]
    render :layout => 'base'
  end
  
  def share
    @shares = @project.shares.reverse
    @base_courses_tag = @project.project_type
    respond_to do |format|
      format.html{render :layout => 'base_courses' if @base_courses_tag==1}
      format.api
    end
  end

  def create
    @issue_custom_fields = IssueCustomField.sorted.all
    @trackers = Tracker.sorted.all
    @project = Project.new
    @project.safe_attributes = params[:project]
    if validate_parent_id && @project.save
      @project.set_allowed_parent!(params[:project]['parent_id']) if params[:project].has_key?('parent_id')
      # Add current user as a project member if he is not admin
      #unless User.current.admin?
      r = Role.givable.find_by_id(Setting.new_project_user_role_id.to_i) || Role.givable.first
      m = Member.new(:user => User.current, :roles => [r])
      project_info = ProjectInfo.new(:user_id => User.current.id, :project_id => @project.id)
      user_grades =  UserGrade.create(:user_id => User.current.id, :project_id => @project.id)
      Rails.logger.debug "UserGrade created: #{user_grades.to_json}"
      #if params[:project][:is_public] == '1'
        project_status = ProjectStatus.create(:project_id => @project.id, :watchers_count => 0, :changesets_count => 0, :project_type => @project.project_type,:grade => 0)
        Rails.logger.debug "ProjectStatus created: #{project_status.to_json}"
      #end
      @project.members << m
      @project.project_infos << project_info
      #end
      respond_to do |format|
        format.html {
          flash[:notice] = l(:notice_successful_create)
          if params[:continue]
            attrs = {:parent_id => @project.parent_id}.reject {|k,v| v.nil?}
            redirect_to new_project_url(attrs, :course => '0')
          else
            redirect_to settings_project_url(@project)
          end
        }
        format.api  { render :action => 'show', :status => :created, :location => url_for(:controller => 'projects', :action => 'show', :id => @project.id) }
      end
    else
      respond_to do |format|
        format.html { render :action => 'new', :layout => 'base'}#Added by young
        format.api  { render_validation_errors(@project) }
      end
    end
  end

  def copy
    @issue_custom_fields = IssueCustomField.sorted.all
    @trackers = Tracker.sorted.all
    @source_project = Project.find(params[:id])
    if request.get?
      @project = Project.copy_from(@source_project)
      @project.identifier = Project.next_identifier if Setting.sequential_project_identifiers?
    else
      Mailer.with_deliveries(params[:notifications] == '1') do
        @project = Project.new
        @project.safe_attributes = params[:project]
        if validate_parent_id && @project.copy(@source_project, :only => params[:only])
          @project.set_allowed_parent!(params[:project]['parent_id']) if params[:project].has_key?('parent_id')
          flash[:notice] = l(:notice_successful_create)
          redirect_to settings_project_url(@project)
        elsif !@project.new_record?
          # Project was created
          # But some objects were not copied due to validation failures
          # (eg. issues from disabled trackers)
          # TODO: inform about that
          redirect_to settings_project_url(@project)
        end
      end
    end
  rescue ActiveRecord::RecordNotFound
  # source_project not found
    render_404
    end

  # Show @project
  def show
    @project_type = params[:project_type]
    
    # try to redirect to the requested menu item
    if params[:jump] && redirect_to_project_menu_item(@project, params[:jump])
    return
    end

    @users_by_role = @project.users_by_role
    @subprojects = @project.children.visible.all
    @news = @project.news.limit(5).includes(:author, :project).reorder("#{News.table_name}.created_on DESC").all
    @trackers = @project.rolled_up_trackers
    if(User.find_by_id(ProjectInfo.find_by_project_id(@project.id).try(:user_id)))
	     @user = User.find_by_id(ProjectInfo.find_by_project_id(@project.id).user_id)
	  end
    cond = @project.project_condition(Setting.display_subprojects_issues?)
    @open_issues_by_tracker = Issue.visible.open.where(cond).count(:group => :tracker)
    @total_issues_by_tracker = Issue.visible.where(cond).count(:group => :tracker)

    if User.current.allowed_to?(:view_time_entries, @project)
      @total_hours = TimeEntry.visible.sum(:hours, :include => :project, :conditions => cond).to_f
    end

    @key = User.current.rss_key
    #新增内容
    @days = Setting.activity_days_default.to_i

    if params[:from]
      begin; @date_to = params[:from].to_date + 1; rescue; end
    end

    has = {
      "show_issues" => true,
      "show_files" => true,
      "show_documents" => true,
      "show_messages" => true,
      "show_news" => true,
      "show_bids" => true,
      "show_contests" => true,
      "show_wiki_edits"=>true,
      "show_journals_for_messages" => true
    }
    @date_to ||= Date.today + 1
    @date_from = @date_to - @days-1.years
    @with_subprojects = params[:with_subprojects].nil? ? Setting.display_subprojects_issues? : (params[:with_subprojects] == '1')
    @author = (params[:user_id].blank? ? nil : User.active.find(params[:user_id]))
    # 决定显示所用用户或单个用户活动
    @activity = Redmine::Activity::Fetcher.new(User.current, :project => @project,
                                                             :with_subprojects => @with_subprojects,
                                                             :author => @author)
    @activity.scope_select {|t| !has["show_#{t}"].nil?}
    # logger.debug "=========================================#{@activity.scope}"
    #   @activity.scope = (@author.nil? ? :default : :all) if @activity.scope.empty?

    # modify by nwb
    # 添加私密性判断
    if User.current.member_of?(@project)|| User.current.admin?
      events = @activity.events(@date_from, @date_to)
    else
      events = @activity.events(@date_from, @date_to, :is_public => 1)
    end

    @offset, @limit = api_offset_and_limit({:limit => 10})
    @events_count = events.count
    @events_pages = Paginator.new @events_count, @limit, params['page']
    @offset ||= @events_pages.offset
    events = events.slice(@offset,@limit)
    #Ended by young
    @events_by_day = events.group_by {|event| User.current.time_to_date(event.event_datetime)}
    #  documents
    @sort_by = %w(category date title author).include?(params[:sort_by]) ? params[:sort_by] : 'category'
    documents = @project.documents.includes(:attachments, :category).all
    case @sort_by
    when 'date'
      @grouped = documents.group_by {|d| d.updated_on.to_date }
    when 'title'
      @grouped = documents.group_by {|d| d.title.first.upcase}
    when 'author'
      @grouped = documents.select{|d| d.attachments.any?}.group_by {|d| d.attachments.last.author}
    else
    @grouped = documents.group_by(&:category)
    end
    @document = @project.documents.build
    #
    @base_courses_tag = @project.project_type
    #判断能否显示真名（当前用户为课程的教师时显示真名）
    if @project.project_type == Project::ProjectType_course
      @teachers= searchTeacherAndAssistant(@project)
      @canShowRealName = isCourseTeacher(User.current.id)
    end

    # real_name action为虚拟的该方法并不存在，用来辅助判断真名权限
    # @canShowRealName = User.current.allowed_to?({:controller => "projects", :action => "real_name"}, @project || @projects, :global => false)
    respond_to do |format|
      format.html{render :layout => 'base_courses' if @base_courses_tag==1}
      format.api
    end
  end

  def settings
    @issue_custom_fields = IssueCustomField.sorted.all
    @issue_category ||= IssueCategory.new
    @member ||= @project.members.new
    @trackers = Tracker.sorted.all
    @wiki ||= @project.wiki
    #Added by young
    # @course_tag = params[:course]
    # if @course_tag == '1'
    #@course = Course.find_by_extra(@project.identifier)
    # if @project.project_type == 1
    #   render :layout => 'base_courses'
    # else
    #   render :layout => 'base_projects'
    # end
  #Ended by young
  end

  def edit
  end

  #by young
  include CoursesHelper
  def member
    ## 有角色参数的才是课程，没有的就是项目
    @render_file = 'member_list'
    # 判断是否课程
    if @project.project_type == Project::ProjectType_course
      @teachers= searchTeacherAndAssistant(@project)
      @canShowCode = isCourseTeacher(User.current.id)
      case params[:role]
      when '1'
        @subPage_title = l :label_teacher_list
        @members = searchTeacherAndAssistant(@project) 
      when '2'
        @subPage_title = l :label_student_list 
        @members = searchStudent(@project)
      else
        @subPage_title = ''
        @members = @project.member_principals.includes(:roles, :principal).all.sort
      end
    else # @project.project_type == Project::ProjectType_project
      roles = Role.find_all_givable
      @subPage_title = l :label_member_list
      @members = @project.member_principals.includes(:roles, :principal).joins("LEFT JOIN #{OptionNumber.table_name} ON #{OptionNumber.table_name}.user_id = #{Member.table_name}.user_id and #{OptionNumber.table_name}.score_type = 2 AND #{Member.table_name}.project_id = #{OptionNumber.table_name}.project_id").order("#{OptionNumber.table_name}.total_score DESC").all
      #@members = sort_project_members(@project, @members)
      @applied_members = appied_project_members(@project, @members)
    end
    @members = paginateHelper @members
    render :layout => 'base_courses' if @project.project_type == 1
  end

  #判断指定用户是否为课程教师
  def isCourseTeacher(id)
     result = false
    if  @teachers.find_by_user_id(id) != nil
      result = true
    end
    result
  end

  def sort_project_members project, members
    #userGrade = UserGrade.where(:project_id => project.id)
    users = UserGrade.where(:project_id => project.id).
            order('grade DESC').
            joins("LEFT JOIN users ON users.id = user_grades.id").
            select("DISTINCT user_grades.user_id")
    memberlist = []
    users.each do |user|
      members.each do |member|
        if member[:user_id] == user[:user_id]
          memberlist << member
        end
      end
    end
    memberlist
  end

  def appied_project_members (project, members)
    users = AppliedProject.where(:project_id => project.id)
    memberlist = []
    users.each do |user|
      members.each do |member|
        if member[:user_id] == user[:user_id]
          memberlist << member
        end
      end
    end
    memberlist
  end

  def file
  end

  def statistics

  end
  #end

  def update
    @project.safe_attributes = params[:project]
    #@project.dts_test = params[:project][:dts_test]
    if validate_parent_id && @project.save
      @course = Course.find_by_extra(@project.identifier)
      unless @course.nil?
      @course.password = params[:project][:course][:password]
   # added by bai
      @course.term = params[:term]
      @course.time = params[:time]
      @course.setup_time = params[:setup_time]
      @course.endup_time = params[:endup_time]
      @course.class_period = params[:class_period]
   # end
      @course.save
      end           
      @project.set_allowed_parent!(params[:project]['parent_id']) if params[:project].has_key?('parent_id')
            
      if params[:project][:is_public] == '0'
        project_status = ProjectStatus.find_by_project_id(@project.id)
        project_status.destroy if project_status
      elsif params[:project][:is_public] == '1'
        project_status = ProjectStatus.create(:project_id => @project.id, :watchers_count => @project.watchers.count, :changesets_count => @project.changesets.count,:grade => 0, :project_type => @project.project_type)
      end

      respond_to do |format|
        format.html {
          flash[:notice] = l(:notice_successful_update)
          redirect_to settings_project_url(@project,:course => @project.project_type)
        }
        format.api  { render_api_ok }
      end
    else
      respond_to do |format|
        format.html {
          settings
          render :action => 'settings'
        }
        format.api  { render_validation_errors(@project) }
      end
    end
  end

  def modules
    @project.enabled_module_names = params[:enabled_module_names]
    flash[:notice] = l(:notice_successful_update)
    redirect_to settings_project_url(@project, :tab => 'modules')
  end

  def archive
    if request.post?
      unless @project.archive
        flash[:error] = l(:error_can_not_archive_project)
      end
    end
    redirect_to admin_projects_url(:status => params[:status])
  end

  def unarchive
    @project.unarchive if request.post? && !@project.active?
    redirect_to admin_projects_url(:status => params[:status])
  end

  def close
    @project.close
    redirect_to project_url(@project)
  end

  def reopen
    @project.reopen
    redirect_to project_url(@project)
  end

  # Delete @project
  def destroy
    @project_to_destroy = @project
    if api_request? || params[:confirm]
      @project_to_destroy.destroy
      respond_to do |format|
        format.html { redirect_to admin_projects_url }
        format.api  { render_api_ok }
      end
    else
      render :layout => "project_base"
    end
    # hide project in layout
    @project = nil
  end

  def show_projects_score
    respond_to do |format|
      format.html { render :layout => "project_base"}
      format.js
    end
  end
  
  def issue_score_index
       respond_to do |format|
         format.js
       end
  end
  
  def news_score_index
    
  end
  
  def file_score_index
    
  end
  
  def code_submit_score_index
    
  end
  
  def projects_topic_score_index
    
  end
# end

  before_filter :toggleCourse, only: [:finishcourse, :restartcourse]
  # 最好通过用户与项目的权限解决这种事情。还没写
  def finishcourse
    yesterday = Date.today.prev_day.to_time

    @course_prefs.endup_time = yesterday
    @save_flag = @course_prefs.save

    respond_to do |format|
      format.js
    end
  end

  def restartcourse
    day = Time.parse("3000-01-01")

    @course_prefs.endup_time = day
    @save_flag = @course_prefs.save

    respond_to do |format|
      format.js {
        render action:'finishcourse'
      }
    end
  end

  def exit_project
    @project = Project.find params[:id]
    if  User.current.login?
      members = Member.where(:user_id => User.current.id, :project_id=>params[:id]).first
      if  members != nil && members.roles.first.to_s != "Manager"
        members.destroy
      end
      respond_to do |format|
        format.js
      end
    end
  end
  private

  def memberAccess
    # 是课程，则判断当前用户是否参加了课程
    return 0 if @project.project_type == Project::ProjectType_project
    currentUser = User.current
    render_403 unless currentUser.member_of?(@project)
  end

  def toggleCourse
    @course_prefs = Course.find_by_extra(@project.identifier)
    unless (@course_prefs.teacher == User.current || User.current.admin?)
      render_403
    end
  end


  def select_project_layout
    project = Project.find_by_id(params[:id])
    project ||= @project ||= @course ||= params[:course] ||= params[:project_type]
    (project.try(:project_type) == Project::ProjectType_project) ? 'base_projects' : 'base_courses'
  end

  # Validates parent_id param according to user's permissions
  # TODO: move it to Project model in a validation that depends on User.current
  def validate_parent_id
    return true if User.current.admin?
    parent_id = params[:project] && params[:project][:parent_id]
    if parent_id || @project.new_record?
      parent = parent_id.blank? ? nil : Project.find_by_id(parent_id.to_i)
      unless @project.allowed_parents.include?(parent)
        @project.errors.add :parent_id, :invalid
      return false
      end
    end
    true
  end

  # added by huang

  def watcherlist
    if @watched
       @users -= watched.watcher_users
    end
  end



  #gcm
  def get_project_activity projects,activities
    @project_ids=activities.keys()

    days = Setting.activity_days_default.to_i
    date_to ||= Date.today + 1
    date_from = date_to - days-1.years

    #issue_count
    Issue.where(project_id: @project_ids).where("updated_on>?",date_from).each do |issue|
#      activities[issue.project_id.to_s]+=1
      activities[issue.project_id]+=issue.journals.where("created_on>?",date_from).count
    end

    #repository_count
    Repository.where(project_id: @project_ids).each do |repository|
#      activities[repository.project_id.to_s]+=1
      activities[repository.project_id]+=repository.changesets.where("committed_on>?",date_from).count
    end


    #news_count
    News.where(project_id: @project_ids).where("created_on>?",date_from).each do |news|
      activities[news.project_id]+=1
    end

    #document_count
    Document.where(project_id: @project_ids).where("created_on>?",date_from).each do |document|
      activities[document.project_id]+=1
    end

    #file_count
    Attachment.where(container_id: @project_ids, container_type: Project).where("created_on>?",date_from).each do |attachment|
      activities[attachment.container_id]+=1
    end

    #message_count
    Board.where(project_id: @project_ids).each do |board|
#      activities[board.project_id]+=1
      activities[board.project_id]+=board.messages.where("updated_on>?",date_from).count
    end

    #time_entry_count
    TimeEntry.where(project_id: @project_ids).where("updated_on>?",date_from).each do |timeentry|
      activities[timeentry.project_id]+=1
    end

    #feedbackc_count
    JournalsForMessage.where(jour_id: @project_ids, jour_type: Project).each do |jourformess|
      activities[jourformess.jour_id]+=1
    end

    #activities!=0
    i=0;
    projects.each do |project|
      id=project.id
      if activities[id]==0
        activities[id]=1
      end
    end

    return activities
  end
  #gcmend

  #gcm
  def handle_project projects,activities
    project_activity_count_array=activities.values()

    project_array=[]
    i=0;
    projects.each do |project|
      project_array[i]=project
      i=i+1
    end

    projects=desc_sort_course_by_avtivity(project_activity_count_array,project_array)

    return projects
  end
  #gcmend


  #gcm
  def desc_sort_course_by_avtivity(activity_count,projects)
    return projects if activity_count.size<2
    (activity_count.size-2).downto(0) do |i|
      (0..i).each do |j|
        if activity_count[j]<activity_count[j+1]
          projects[j],projects[j+1]=projects[j+1],projects[j]
          activity_count[j],activity_count[j+1]=activity_count[j+1],activity_count[j]
        end
      end
    end
    return projects
  end
  #gcmend


end
